class PluginTemplate
	include Mongoid::Document
	include Mongoid::Timestamps
	include OrbitModel::Status
	include MemberHelper
	include Admin::PluginTemplatesHelper
	include Slug

	col_fields

	plugin_template_related_files_fields

	parse_again_start
	belongs_to :plugin_template_related
	parse_again_end

	field :rss2_id
	belongs_to :member_profile
	index(plugin_template_sort_hash, { unique: false, background: false })
	scope :sort_hash, ->{ order_by(plugin_template_sort_hash) }
	scope :sort_for_frontend, ->{ where(:is_hidden=>false).order_by(plugin_template_sort_hash) }

	parse_again_start
	member_methods_define
	parse_again_end
	parse_again_start
	periodic_methods_define
	parse_again_end
	before_save do
	  before_save_codes
	end
	def parse_time(time_str)
	  DateTime.parse("0000-01-01 " + time_str)
	end
	parse_again_start * 1 if is_one_line_title.count > 0
	def create_link
		one_line_title_format_code
    end
    parse_again_end
	def self.get_plugin_datas_to_member(datas)
		page = Page.where(:module => "personal_plugin_template").first rescue nil
		parse_again_start * 1 if is_one_line_title.count > 0
		title_is_paper_format = true
		if !page.nil? && page.custom_string_field == "table"
			title_is_paper_format = false
			if !page.custom_array_field.blank?
				fields_to_show = page.custom_array_field
			else
				fields_to_show = col_name_to_show
			end
		else
			fields_to_show = col_name_to_show_short
		end
		parse_again_end
		parse_again_start * 1 if is_one_line_title.count == 0
		title_is_paper_format = false
		if !page.nil? && !page.custom_array_field.blank?
			fields_to_show = page.custom_array_field
		else
			fields_to_show = col_name_to_show
		end
		parse_again_end

		fields_to_remove = []

		pd_title = []

		fields_to_show.each do |t|
			if (self.fields[t].type.to_s == "String" || self.fields[t].type.to_s == "Object" rescue false)
				fields_to_remove << t if (datas.where(t.to_sym.ne => nil, t.to_sym.ne => "").count == 0 rescue false)
			elsif (self.relations.include?(t.pluralize) rescue false)
				fields_to_remove << t if (datas.where(t.pluralize.to_sym.ne=>[]).count == 0 rescue false)
			elsif period_fields_text.include?(t)
				fields_to_remove << t if (datas.select{|d| d.send(t) != " ~ " }.count == 0 rescue false)
			else
				fields_to_remove << t if (datas.where(t.to_sym.ne => nil).count == 0 rescue false)
			end
			pd_title << {
			  "plugin_data_title" => I18n.t("personal_plugin_template.#{t}")
			} if !fields_to_remove.include?(t)
		end

		fields_to_show = fields_to_show - fields_to_remove

		plugin_datas = datas.sort_for_frontend.collect.with_index do |p,idx|

			pd_data = []
			fields_to_show.collect do |t|
				pd_data << { "data_title" => p.display_field(t, false, title_is_paper_format) }
			end
			parse_again_start * 1 if plugin_template_related.count > 0
			{
				"pd_datas" => pd_data,
				"type-sort" => (p.plugin_template_related.sort_position.to_i rescue 1000),
				"sort-index" => idx
			}
			parse_again_end
			parse_again_start * 1 if plugin_template_related.count == 0
			{
				"pd_datas" => pd_data
			}
			parse_again_end
		end
		parse_again_start * 1 if plugin_template_related.count > 0
		plugin_datas = plugin_datas.sort_by{|pd| [pd["type-sort"], pd["sort-index"]]}
		parse_again_end
		return [pd_title,plugin_datas]
	end

	def get_plugin_data(fields_to_show)
		plugin_datas = []
		fields_to_show.each do |field|
			plugin_data = self.get_plugin_field_data(field) rescue nil
			next if plugin_data.blank? or plugin_data['value'].blank?
			plugin_datas << plugin_data
		end
		plugin_datas
	end

	def get_plugin_field_data(field)
		plugin_template = self
		value_case_codes

		value = (value =~ /\A#{URI::regexp(['http', 'https'])}\z/) ? "<a href='#{value}' target='blank'>#{value}</a>" : value

		{
			"key"=>field,
			"title_class"=>"plugin_template-#{field.gsub('_','-')}-field",
			"value_class"=>"plugin_template-#{field.gsub('_','-')}-value",
			"title"=>I18n.t('personal_plugin_template.'+field),
			"value"=>value
		}
	end

	def display_field(field,text_only=false,title_is_paper_format=false)
		plugin_template = self
		display_field_code
	end
end